#include <atmel_start.h>

#include "usb_debug.h"

extern uint8_t _binary_mod_fw_bin_start;
extern uint8_t _binary_mod_fw_bin_end;

extern uint32_t _smockbl;
extern uint32_t _emockbl;
extern uint32_t _smodfw;
extern uint32_t _emodfw;

#define MOCK_BOOTLOADER_START_ADDRESS 0x20000

int comp_sysv_checksum()
{
        uint32_t result = 0;
        uint16_t result16 = 0;
        uint8_t *p = (uint8_t*)&_smodfw;
        while (p != (uint8_t*)&_emodfw)
                result += *(p++);
        result16 = (result & 0xffff) + ((result & 0xffffffff) >> 16);
        return (result16 & 0xffff) + (result16 >> 16);
}

void jump_to_mockbl()
{
        uint32_t app_start_address;
        app_start_address = *(uint32_t *)(MOCK_BOOTLOADER_START_ADDRESS + 4);

        /* Rebase the Stack Pointer */
        __set_MSP(*(uint32_t *)MOCK_BOOTLOADER_START_ADDRESS);

        /* Rebase the vector table base address */
        SCB->VTOR = ((uint32_t)MOCK_BOOTLOADER_START_ADDRESS & SCB_VTOR_TBLOFF_Msk);

        /* Jump to application Reset Handler in the application */
        asm("bx %0" ::"r"(app_start_address));
}

static struct io_descriptor *io;

static void I2C_0_rx_complete(const struct i2c_s_async_descriptor *const descr)
{
	uint8_t c;

	io_read(io, &c, 1);
        debug("got character %c", c);
        delay_ms(10);
}

void I2C_0_example(void)
{
	i2c_s_async_get_io_descriptor(&I2C_0, &io);
	i2c_s_async_register_callback(&I2C_0, I2C_S_RX_COMPLETE, I2C_0_rx_complete);
	i2c_s_async_enable(&I2C_0);
}

int main(void)
{
	/* Initializes MCU, drivers and middleware */
	atmel_start_init();
        int i = 0;

	adc_sync_enable_channel(&ADC_0, 0);

        uint16_t adc_val;
        float adc_temp;

        uint16_t checksum;
        checksum = comp_sysv_checksum();

        I2C_0_example();

	/* Replace with your application code */
	while (1) {
                delay_ms(500);
                gpio_toggle_pin_level(LED);
                if (i++ % 2) {
                        adc_sync_read_channel(&ADC_0, 0, (uint8_t*)&adc_val, 2);
                        adc_temp = ((adc_val / 4095.0) - 0.6)/0.01;
                        debug("slave iter %d, temp=%.1f", i/2, adc_temp);
                }
                /* if (i == 10) { */
                /*         usbdc_detach (); */
                /*         usbdc_stop (); */
                /*         usbdc_deinit (); */

                /*         jump_to_mockbl(); */
                /* } */
	}
}
